#!/bin/sh
# the next line restart using pgtclsh \
exec pgtclsh "$0" "$@"

# by Rocco 20-11-2001

# Usage: postpg_restore.tcl <dbname>



if  [expr (($argc < 1) || ($argc > 1))] {
        puts [format "Usage: postpg_restore.tcl <dbname>\n\a"]
        exit
        }


set dbname [lindex $argv 0]
set quotchar {"}

set port 5432

set lotype lo


# connect to dbname
if [catch {pg_connect $dbname -host localhost -port $port} lconn] {
        puts [format "Error connecting to $dbname:\n$lconn"]
        return -1
        }



set sqlfname [file join /tmp $dbname.upd]
set sqlfout [open  $sqlfname w+]
fconfigure $sqlfout -buffering none


# populating LO map array
catch {unset lomap}
set query "select * from oid2lo"
pg_select $lconn $query row {
	set lomap($row(lo)) $row(loid)
	#puts "lomap( $row(lo) ) --> $row(loid)"
	}


# search for ALL user tables with lo type fields
set query "select c.relname as table, a.attname as lofield from pg_class c, pg_attribute a, pg_type t where a.attrelid=c.oid  and a.atttypid=t.oid and  t.typname=\'$lotype\' and a.attnum>0 and c.relname not like \'pg\\_%\' and  c.relname not like \'pgr\\_%\'"
catch {unset listlofields}
pg_select $lconn $query lofields {
        lappend listlofields($lofields(table)) $lofields(lofield)
        }



# scan tables with lo fields updating LO value from oid2lo
puts  "scan tables with LO fields ..."
foreach table [array names listlofields] {

        # table lofields
        set lofields  $listlofields($table)
        set lofieldsString [join $lofields ", "]
        puts "working on $table: $lofieldsString"
        
        set query "select oid, $lofieldsString from $table"
        pg_select $lconn $query row {
		set lofields2updateset {}
                foreach lofield $lofields {
                        if {[string compare $row($lofield) ""]!=0} {
				#puts "$table - $lofield - $row($lofield)"
				if {[info exists lomap($row($lofield))]} {
					lappend lofields2updateset "$lofield = $lomap($row($lofield))::$lotype"
					}
                                }
                        };# end of foreach
		if {[llength $lofields2updateset]>0} {
			set lofields2updsetString [join $lofields2updateset ", "]
			set uquery "update $table set $lofields2updsetString where oid = $row(oid);"
			puts $sqlfout $uquery
			}
                };# end of pg_select 

        };# end of foreach


close $sqlfout


eval exec psql -f $sqlfname $dbname


# dropping oid2lo table
puts "dropping oid2lo table in $dbname"
set query "drop table oid2lo"
#catch {pg_exec $lconn $query}


pg_disconnect $lconn

puts "\npostpg_restore  Done!\n"


