#!/bin/sh
# the next line restart using pgtclsh \
exec pgtclsh "$0" "$@"

# by Rocco 20-11-2001

# Usage: prepg_dump.tcl <dbname>


if  [expr (($argc < 1) || ($argc > 1))] {
        puts [format "Usage: prepg_dump.tcl <dbname>\n\a"]
        exit
        }


set dbname [lindex $argv 0]
set quotchar {"}

set port 5432

# connect to dbname
if [catch {pg_connect $dbname -host localhost -port $port} lconn] {
        puts [format "Error connecting to $dbname:\n$lconn"]
        return -1
        }



set query "drop table oid2lo"
catch {pg_exec $lconn $query}

set query "create table oid2lo (loid oid, lo int4)"
puts "$query..."
set ris [pg_exec $lconn $query]
puts [pg_result $ris -status]
pg_result $ris -clear


puts "populating oid2lo..."
set query "select distinct loid from pg_largeobject"
pg_select $lconn $query row {
	set lo $row(loid)
	set query "insert into oid2lo values ($lo, $lo)"
	set ris [pg_exec $lconn $query]
	pg_result $ris -clear
	}


puts "\nprepg_dump Done!"

pg_disconnect $lconn


